
#ifndef FINITELINEARGROUP_H
#define FINITELINEARGROUP_H
 
#include <iostream>
#include <giac/giac.h>

#include <string>
#include <map>
#include <algorithm>

using namespace std;
using namespace giac;

#include "CMfield.h"
#include "Util.h"

extern context ct;
class FiniteLinearGroup: public CMfield
{
  public:

  FiniteLinearGroup(string s);

  vector<gen> elements;

  int oldnumber;
 
  bool isgroup;

  void addElements(vector<gen> list);
  void addElement(gen M);

  bool isNew(gen M);
  bool isInList(gen M,vector<gen> list);

  void expand();
  void expandToGroup();

};

#endif
